var __create = Object.create;
var __defProp = Object.defineProperty;
var __defProps = Object.defineProperties;
var __getOwnPropDesc = Object.getOwnPropertyDescriptor;
var __getOwnPropDescs = Object.getOwnPropertyDescriptors;
var __getOwnPropNames = Object.getOwnPropertyNames;
var __getOwnPropSymbols = Object.getOwnPropertySymbols;
var __getProtoOf = Object.getPrototypeOf;
var __hasOwnProp = Object.prototype.hasOwnProperty;
var __propIsEnum = Object.prototype.propertyIsEnumerable;
var __defNormalProp = (obj, key, value) => key in obj ? __defProp(obj, key, { enumerable: true, configurable: true, writable: true, value }) : obj[key] = value;
var __spreadValues = (a, b) => {
  for (var prop in b || (b = {}))
    if (__hasOwnProp.call(b, prop))
      __defNormalProp(a, prop, b[prop]);
  if (__getOwnPropSymbols)
    for (var prop of __getOwnPropSymbols(b)) {
      if (__propIsEnum.call(b, prop))
        __defNormalProp(a, prop, b[prop]);
    }
  return a;
};
var __spreadProps = (a, b) => __defProps(a, __getOwnPropDescs(b));
var __markAsModule = (target) => __defProp(target, "__esModule", { value: true });
var __export = (target, all) => {
  for (var name in all)
    __defProp(target, name, { get: all[name], enumerable: true });
};
var __reExport = (target, module2, copyDefault, desc) => {
  if (module2 && typeof module2 === "object" || typeof module2 === "function") {
    for (let key of __getOwnPropNames(module2))
      if (!__hasOwnProp.call(target, key) && (copyDefault || key !== "default"))
        __defProp(target, key, { get: () => module2[key], enumerable: !(desc = __getOwnPropDesc(module2, key)) || desc.enumerable });
  }
  return target;
};
var __toESM = (module2, isNodeMode) => {
  return __reExport(__markAsModule(__defProp(module2 != null ? __create(__getProtoOf(module2)) : {}, "default", !isNodeMode && module2 && module2.__esModule ? { get: () => module2.default, enumerable: true } : { value: module2, enumerable: true })), module2);
};
var __toCommonJS = /* @__PURE__ */ ((cache) => {
  return (module2, temp) => {
    return cache && cache.get(module2) || (temp = __reExport(__markAsModule({}), module2, 1), cache && cache.set(module2, temp), temp);
  };
})(typeof WeakMap !== "undefined" ? /* @__PURE__ */ new WeakMap() : 0);

// src/index.ts
var src_exports = {};
__export(src_exports, {
  download: () => download
});
var import_download = __toESM(require("download"));
var import_git_clone = __toESM(require("git-clone"));
var import_rimraf = __toESM(require("rimraf"));
function download(repo, dest, opts, fn) {
  if (typeof opts === "function") {
    fn = opts;
    opts = null;
  }
  opts = opts || {};
  const clone = opts.clone || false;
  delete opts.clone;
  const newRepo = normalize(repo);
  let url = "";
  if (newRepo)
    url = (newRepo == null ? void 0 : newRepo.url) || getUrl(newRepo, clone) || "";
  if (clone && url) {
    const cloneOptions = __spreadValues({
      checkout: newRepo == null ? void 0 : newRepo.checkout,
      shallow: (newRepo == null ? void 0 : newRepo.checkout) === "master"
    }, opts);
    (0, import_git_clone.default)(url, dest, cloneOptions, (err) => {
      if (err === void 0) {
        (0, import_rimraf.default)(`${dest}/.git`, () => {
        });
        fn();
      } else {
        fn(err);
      }
    });
  } else {
    const downloadOptions = __spreadProps(__spreadValues({
      extract: true,
      strip: 1,
      mode: "666"
    }, opts), {
      headers: __spreadValues({
        accept: "application/zip"
      }, opts.headers || {})
    });
    (0, import_download.default)(url, dest, downloadOptions).then(() => {
      fn();
    }).catch((err) => {
      fn(err);
    });
  }
}
function normalize(repo) {
  if (typeof repo === "string") {
    let regex = /^(?:(direct):([^#]+)(?:#(.+))?)$/;
    let match = regex.exec(repo);
    if (match) {
      const url = match[2];
      const directCheckout = match[3] || "master";
      return {
        type: "direct",
        url,
        checkout: directCheckout
      };
    } else {
      regex = /^(?:(github|gitlab|bitbucket):)?(?:(.+):)?([^/]+)\/([^#]+)(?:#(.+))?$/;
      match = regex.exec(repo);
      const type = (match == null ? void 0 : match[1]) || "github";
      let origin = (match == null ? void 0 : match[2]) || null;
      const owner = match == null ? void 0 : match[3];
      const name = match == null ? void 0 : match[4];
      const checkout = (match == null ? void 0 : match[5]) || "master";
      if (origin == null) {
        if (type === "github")
          origin = "github.com";
        else if (type === "gitlab")
          origin = "gitlab.com";
        else if (type === "bitbucket")
          origin = "bitbucket.org";
      }
      return {
        type,
        origin,
        owner,
        name,
        checkout
      };
    }
  }
}
function addProtocol(origin, clone) {
  if (!/^(f|ht)tps?:\/\//i.test(origin)) {
    if (clone)
      origin = `git@${origin}`;
    else
      origin = `https://${origin}`;
  }
  return origin;
}
function getUrl(repo, clone) {
  let url;
  let origin = repo.origin && addProtocol(repo.origin, clone) || "";
  if (/^git@/i.test(origin))
    origin = `${origin}:`;
  else
    origin = `${origin}/`;
  if (clone) {
    url = `${origin + repo.owner}/${repo.name}.git`;
  } else {
    if (repo.type === "github") {
      url = `${origin + repo.owner}/${repo.name}/archive/${repo.checkout}.zip`;
    } else if (repo.type === "gitlab") {
      url = `${origin + repo.owner}/${repo.name}/repository/archive.zip?ref=${repo.checkout}`;
    } else if (repo.type === "bitbucket") {
      url = `${origin + repo.owner}/${repo.name}/get/${repo.checkout}.zip`;
    }
  }
  return url;
}
module.exports = __toCommonJS(src_exports);
// Annotate the CommonJS export names for ESM import in node:
0 && (module.exports = {
  download
});
