var __defProp = Object.defineProperty;
var __defProps = Object.defineProperties;
var __getOwnPropDescs = Object.getOwnPropertyDescriptors;
var __getOwnPropSymbols = Object.getOwnPropertySymbols;
var __hasOwnProp = Object.prototype.hasOwnProperty;
var __propIsEnum = Object.prototype.propertyIsEnumerable;
var __defNormalProp = (obj, key, value) => key in obj ? __defProp(obj, key, { enumerable: true, configurable: true, writable: true, value }) : obj[key] = value;
var __spreadValues = (a, b) => {
  for (var prop in b || (b = {}))
    if (__hasOwnProp.call(b, prop))
      __defNormalProp(a, prop, b[prop]);
  if (__getOwnPropSymbols)
    for (var prop of __getOwnPropSymbols(b)) {
      if (__propIsEnum.call(b, prop))
        __defNormalProp(a, prop, b[prop]);
    }
  return a;
};
var __spreadProps = (a, b) => __defProps(a, __getOwnPropDescs(b));

// src/index.ts
import downloadUrl from "download";
import gitclone from "git-clone";
import rimraf from "rimraf";
function download(repo, dest, opts, fn) {
  if (typeof opts === "function") {
    fn = opts;
    opts = null;
  }
  opts = opts || {};
  const clone = opts.clone || false;
  delete opts.clone;
  const newRepo = normalize(repo);
  let url = "";
  if (newRepo)
    url = (newRepo == null ? void 0 : newRepo.url) || getUrl(newRepo, clone) || "";
  if (clone && url) {
    const cloneOptions = __spreadValues({
      checkout: newRepo == null ? void 0 : newRepo.checkout,
      shallow: (newRepo == null ? void 0 : newRepo.checkout) === "master"
    }, opts);
    gitclone(url, dest, cloneOptions, (err) => {
      if (err === void 0) {
        rimraf(`${dest}/.git`, () => {
        });
        fn();
      } else {
        fn(err);
      }
    });
  } else {
    const downloadOptions = __spreadProps(__spreadValues({
      extract: true,
      strip: 1,
      mode: "666"
    }, opts), {
      headers: __spreadValues({
        accept: "application/zip"
      }, opts.headers || {})
    });
    downloadUrl(url, dest, downloadOptions).then(() => {
      fn();
    }).catch((err) => {
      fn(err);
    });
  }
}
function normalize(repo) {
  if (typeof repo === "string") {
    let regex = /^(?:(direct):([^#]+)(?:#(.+))?)$/;
    let match = regex.exec(repo);
    if (match) {
      const url = match[2];
      const directCheckout = match[3] || "master";
      return {
        type: "direct",
        url,
        checkout: directCheckout
      };
    } else {
      regex = /^(?:(github|gitlab|bitbucket):)?(?:(.+):)?([^/]+)\/([^#]+)(?:#(.+))?$/;
      match = regex.exec(repo);
      const type = (match == null ? void 0 : match[1]) || "github";
      let origin = (match == null ? void 0 : match[2]) || null;
      const owner = match == null ? void 0 : match[3];
      const name = match == null ? void 0 : match[4];
      const checkout = (match == null ? void 0 : match[5]) || "master";
      if (origin == null) {
        if (type === "github")
          origin = "github.com";
        else if (type === "gitlab")
          origin = "gitlab.com";
        else if (type === "bitbucket")
          origin = "bitbucket.org";
      }
      return {
        type,
        origin,
        owner,
        name,
        checkout
      };
    }
  }
}
function addProtocol(origin, clone) {
  if (!/^(f|ht)tps?:\/\//i.test(origin)) {
    if (clone)
      origin = `git@${origin}`;
    else
      origin = `https://${origin}`;
  }
  return origin;
}
function getUrl(repo, clone) {
  let url;
  let origin = repo.origin && addProtocol(repo.origin, clone) || "";
  if (/^git@/i.test(origin))
    origin = `${origin}:`;
  else
    origin = `${origin}/`;
  if (clone) {
    url = `${origin + repo.owner}/${repo.name}.git`;
  } else {
    if (repo.type === "github") {
      url = `${origin + repo.owner}/${repo.name}/archive/${repo.checkout}.zip`;
    } else if (repo.type === "gitlab") {
      url = `${origin + repo.owner}/${repo.name}/repository/archive.zip?ref=${repo.checkout}`;
    } else if (repo.type === "bitbucket") {
      url = `${origin + repo.owner}/${repo.name}/get/${repo.checkout}.zip`;
    }
  }
  return url;
}
export {
  download
};
